/*
     []-------------------------------------------------------------[]
     |		                 GDADOS.C                            |
     |						 	             |
     |     Constroi graficos a partir do arquivo de dados padrao     |
     |						                     |
     |              por Lenimar N. Andrade, junho/97                 |
     []-------------------------------------------------------------[]
*/

#include <math.h>
#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <ctype.h>
#include <string.h>
#include "mouse.c"

#define PI	     3.14159265358979323846
#define PI_SOBRE_2   1.57079632679489661923
#define PI_SOBRE_4   0.78539816339744830961
#define DOIS_PI      6.28318530717958647692
#define INF          1e38
#define IINF         5000

typedef struct { double u, v; } ponto_dominio;  /* Ponto (u, v) no dominio */

/* Constantes nao utilizadas por este programa */
int n_PONTOS = IINF, NIVEL_SUBDIV, DOMINIO2 = 0,
    N_SUBDIV1, N_SUBDIV2, N_SUBDIV3, N_SUBDIV4, N_SUBDIV5,
    INVERSO = 1, VERIFICA_RETORNO = 0;

float PASSO_L, r_erro;

int X_PONTOS_SUBDIVISAO = 0,  /* Marca com "x" pts encontrados subdiv. */
    X_COR_DOMINIO = 8, NIVEL_CLASS, GRADE = 1, DESENHAR_PONTOS_DOM = 1,
    USAR_MOUSE = 1, LINHA_PONTILHADA = 1, DEMORA = 0;

#define TAMANHO(s, tam)       tam = 0; if (s[0]) while(s[++tam])

typedef struct { double xmin, xmax, ymin, ymax; } retangulo;

#include "equacoes.c"

int DES_EIXOS = 0, TAM_EIXOS = 4, COR_EIXOS = 8, COR_GRAF1 = 3,
    GRAF_X = 3, COR_GRAF2 = 4, COR_FUNDO = 0, COR_INTER = 14,
    nuF = 20, nuG = 20, nvF = 20, nvG = 20, X_CENTRO = 319, Y_CENTRO = 239,
    a_domF = 5, b_domF = 10, c_domF = 155, d_domF = 160,
    cor_pontos_domF = 3, cor_molduraF = 8,
    a_domG = 5, b_domG = 250, c_domG = 155, d_domG = 400,
    cor_pontos_domG = 4, cor_molduraG = 8, TAM = 50, corX3D = 15, INICIAL=1;

char ARQ_CONFIGURACAO[100], DIV_NOME_ARQ[30] = "class1.txt" /*subdiv.txt" */ ;

double FI = -PI/4, TETA = -PI/4;

char mens_Dom_F[30] = "Dominio_de_F", mens_Dom_G[30] = "Dominio_de_G",
     DIV_CLASS1[30] = "class1.txt", DIV_CLASS2[30] = "class2.txt";

#ifdef BEZIER
#include "bezier.c"
#endif

/* ---------------------------------------------------------------------- */

int ContaStr(char *x, char *a) {

/* Conta quantas vezes o string "a" aparece no string "x".
   Ex.: ContaStr("Universidade Federal", "de") = 2             */

  int aux = 0, coincide, i = 0, j, k, tam_a, tam_x;

  TAMANHO(x, tam_x);
  TAMANHO(a, tam_a);
  if (tam_x < tam_a) return 0;

  while (i < tam_x) {
    j = i;
    k = 0;
    coincide = 0;

    while ((k < tam_a) && (j < tam_x) && (a[k] == x[j])) {
      coincide++;
      k++;
      j++;
    }

    if (coincide == strlen(a)) aux++;
    i++;
  }
  return aux;
}

/* ---------------------------------------------------------------------- */

void MarcaXDominio(double u, double v, int a, int b, int c, int d,
		   int cor, double x1, double x2, double y1, double y2) {

/* Marca o ponto (u, v) do dominio da parametrizacao de uma superficie
   em forma de "x". E' usado um retangulo definido por (a, b) e (c, d). */

  int A, B;

  A = a + (u - x1)/(x2 - x1)*(c - a);
  B = b + (d - b)*(y2 - v)/(y2 - y1);
  if (a <= A && A <= c && b <= B && B <= d) {
    putpixel(A, B, cor);
    putpixel(A + 1, B + 1, cor);
    putpixel(A + 1, B - 1, cor);
    putpixel(A - 1, B + 1, cor);
    putpixel(A - 1, B - 1, cor);
    putpixel(A + 2, B + 2, cor);
    putpixel(A + 2, B - 2, cor);
    putpixel(A - 2, B + 2, cor);
    putpixel(A - 2, B - 2, cor);
  }
}

/* ----------------------------------------------------------------------- */

void MarcaPontoINI(double u, double v, int a, int b, int c, int d,
	 int cor, double x1, double x2, double y1, double y2, int inicial) {

/* Marca o ponto (u, v) do dominio da parametrizacao de uma superficie
   em forma de "x". E' usado um retangulo definido por (a, b) e (c, d). */

  int A, B;

  A = a + (u - x1)/(x2 - x1)*(c - a);
  B = b + (d - b)*(y2 - v)/(y2 - y1);
  if (a <= A && A <= c && b <= B && B <= d) {
    putpixel(A - 2, B - 2, cor);
    putpixel(A - 1, B - 2, cor);
    putpixel(A    , B - 2, cor);
    putpixel(A + 1, B - 2, cor);
    putpixel(A + 2, B - 2, cor);

    putpixel(A - 2, B + 2, cor);
    putpixel(A - 1, B + 2, cor);
    putpixel(A    , B + 2, cor);
    putpixel(A + 1, B + 2, cor);
    putpixel(A + 2, B + 2, cor);


    putpixel(A - 2, B - 2, cor);
    putpixel(A - 2, B - 1, cor);
    putpixel(A - 2, B   , cor);
    putpixel(A - 2, B + 1, cor);
    putpixel(A - 2, B + 2, cor);


    putpixel(A + 2, B - 2, cor);
    putpixel(A + 2, B - 1, cor);
    putpixel(A + 2, B   , cor);
    putpixel(A + 2, B + 1, cor);
    putpixel(A + 2, B + 2, cor);

    if (!inicial) {
      putpixel(A + 1, B - 1, cor);
      putpixel(A + 1, B   , cor);
      putpixel(A + 1, B + 1, cor);

      putpixel(A - 1, B - 1, cor);
      putpixel(A - 1, B   , cor);
      putpixel(A - 1, B + 1, cor);

      putpixel(A, B - 1, cor);
      putpixel(A, B   , cor);
      putpixel(A, B + 1, cor);
    }

  }
}

/* ----------------------------------------------------------------------- */

int PosUlt(char x, char *s) {

  register int i, tam;

  TAMANHO(s, tam);
  for(i = tam; i >= 0; i--)
    if (s[i] == x) return i;
  return -1;
}

/* ------------------------------------------------------------------------ */

int Pos(char x, char *s) {

  register int i;

  for(i = 0; s[i]; i++)
    if (s[i] == x) return i;
  return -1;
}

/* ------------------------------------------------------------------------ */

#define ELIMINAESPACOS(s) EliminaCaracter(s, ' '); EliminaCaracter(s, 9)

char *EliminaCaracter(char *x, char car_x) {

  register int i, j = 0, comprimento;
  char *aux;

  TAMANHO(x, comprimento);
  if ((aux = (char *) malloc(sizeof(char)*(comprimento + 1))) == NULL)
    return x;

  for (i = 0; i < comprimento; i++)
    if (x[i] != car_x) aux[j++] = x[i];
  aux[j] = '\0';
  strcpy(x, aux);
  free(aux);
  return x;
}

/* ------------------------------------------------------------------------ */

char *Substr(char *s, int inicio, int fim) {

  register int i, tam;

  if (inicio > fim) return NULL;
  if (inicio < 0) inicio = 0;
  TAMANHO(s, tam);
  if (fim >= tam) fim = tam - 1;

  i = inicio;
  while (i <= fim) s[i - inicio] = s[i++];
  s[i - inicio] = '\0';
  return s;
}

/* ------------------------------------------------------------------------ */

#define COMPSTRNI(s1, s2, n) (ComparaNI(s1, s2, n) < 0)

int ComparaNI(char *s1, char *s2, int n) {

  register int i = 0;

  while (i < n && s1[i] != '\0' && s2[i] != '\0' &&
				    toupper(s1[i]) == toupper(s2[i])) i++;
  if (i == n || (s1[i] == '\0' && s2[i] == '\0')) return -1;
  else return i;
}

/* ------------------------------------------------------------------------- */

int InterpretaComando(char *comando) {

  char com_aux[80], result[80];
  int virgula, tam_str, i = 0;

  virgula = Pos(';', comando);
  if (virgula > 0) Substr(comando, 0, virgula - 1);
  ELIMINAESPACOS(comando);
  if (comando[0] == '.' || comando[0] == '%') return 1;
  TAMANHO(comando, tam_str);
  strcpy(com_aux, comando);
  strcpy(result, comando);
  while (comando[i] != '\0' && comando[i] != '=') i++;
  if (comando[i] == '=') {
    Substr(com_aux, 0, i - 1);
    Substr(result, i + 1, tam_str);
  } else return 1;

  if (COMPSTRNI(com_aux, "xcentro", 7)) {
    X_CENTRO = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "ycentro", 7)) {
    Y_CENTRO = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "fi", 2)) {
    FI = atof(result);
  }

  else if (COMPSTRNI(com_aux, "demora", 6)) {
    DEMORA = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "teta", 4)) {
    TETA = atof(result);
  }

  else if (COMPSTRNI(com_aux, "uminf", 5)) {
    Ret1.xmin = atof(result);
  }

  else if (COMPSTRNI(com_aux, "umaxf", 5)) {
    Ret1.xmax = atof(result);
  }

  else if (COMPSTRNI(com_aux, "vminf", 5)) {
    Ret1.ymin = atof(result);
  }

  else if (COMPSTRNI(com_aux, "vmaxf", 5)) {
    Ret1.ymax = atof(result);
  }

  else if (COMPSTRNI(com_aux, "uming", 5)) {
    Ret2.xmin = atof(result);
  }

  else if (COMPSTRNI(com_aux, "umaxg", 5)) {
    Ret2.xmax = atof(result);
  }

  else if (COMPSTRNI(com_aux, "vming", 5)) {
    Ret2.ymin = atof(result);
  }

  else if (COMPSTRNI(com_aux, "vmaxg", 5)) {
    Ret2.ymax = atof(result);
  }

  else if (COMPSTRNI(com_aux, "mens_dom_f", 10)) {
    strcpy(mens_Dom_F, result);
  }

  else if (COMPSTRNI(com_aux, "mens_dom_g", 10)) {
    strcpy(mens_Dom_G, result);
  }

  else if (COMPSTRNI(com_aux, "x_subdiv", 8)) {
    if (toupper(result[0]) == 'S' || result[0] == '1')
      X_PONTOS_SUBDIVISAO = 1;
    else if (toupper(result[0]) == 'N' || result[0] == '0')
      X_PONTOS_SUBDIVISAO = 0;
  }

  else if (COMPSTRNI(com_aux, "graf_x", 6)) {
    if (toupper(result[0]) == 'S' || result[0] == '1')
      GRAF_X = 1;
    else if (toupper(result[0]) == 'N' || result[0] == '0')
      GRAF_X = 0;
  }

  else if (COMPSTRNI(com_aux, "inicial", 7)) {
    if (toupper(result[0]) == 'S' || result[0] == '1')
      INICIAL = 1;
    else if (toupper(result[0]) == 'N' || result[0] == '0')
      INICIAL = 0;
  }

  else if (COMPSTRNI(com_aux, "mouse", 5)) {
    if (toupper(result[0]) == 'S' || result[0] == '1')
      USAR_MOUSE = 1;
    else if (toupper(result[0]) == 'N' || result[0] == '0')
      USAR_MOUSE = 0;
  }

  else if (COMPSTRNI(com_aux, "eixos", 5)) {
    if (toupper(result[0]) == 'S' || result[0] == '1')
      DES_EIXOS = 1;
    else if (toupper(result[0]) == 'N' || result[0] == '0')
      DES_EIXOS = 0;
  }

  else if (COMPSTRNI(com_aux, "pontilhado", 8)) {
    if (toupper(result[0]) == 'S' || result[0] == '1')
      LINHA_PONTILHADA = 1;
    else if (toupper(result[0]) == 'N' || result[0] == '0')
      LINHA_PONTILHADA = 0;
  }

  else if (COMPSTRNI(com_aux, "d_domf", 6)) {
    d_domF = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "c_domf", 6)) {
    c_domF = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "b_domf", 6)) {
    b_domF = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "a_domf", 6)) {
    a_domF = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "d_domg", 6)) {
    d_domG = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "c_domg", 6)) {
    c_domG = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "b_domg", 6)) {
    b_domG = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "a_domg", 6)) {
    a_domG = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "cor_domg", 8)) {
    cor_pontos_domG = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "cor_domf", 8)) {
    cor_pontos_domF = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "cor_moldg", 9)) {
    cor_molduraG = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "cor_moldf", 9)) {
    cor_molduraF = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "cor_inter", 9)) {
    COR_INTER = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "cor_eixos", 9)) {
    COR_EIXOS = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "tam_eixos", 9)) {
    TAM_EIXOS = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "cor_graf1", 9)) {
    COR_GRAF1 = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "cor_graf2", 9)) {
    COR_GRAF2 = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "tam", 3)) {
    TAM = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "cor_fundo", 9)) {
    COR_FUNDO = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "nuf", 3)) {
    nuF = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "nug", 3)) {
    nuG = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "nvf", 3)) {
    nvF = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "nvg", 3)) {
    nvG = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "corx3d", 6)) {
    corX3D = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "xcor", 4)) {
    X_COR_DOMINIO = atoi(result);
  }

  else if (COMPSTRNI(com_aux, "arq_class1", 10)) {
    strcpy(DIV_CLASS1, result);
  }

  else if (COMPSTRNI(com_aux, "arq_class2", 10)) {
    strcpy(DIV_CLASS2, result);
  }

  else if (COMPSTRNI(com_aux, "ptdominio", 8)) {
    if (toupper(result[0]) == 'S' || result[0] == '1')
      DESENHAR_PONTOS_DOM = 1;
    else if (toupper(result[0]) == 'N' || result[0] == '0')
      DESENHAR_PONTOS_DOM = 0;
  }

  else if (COMPSTRNI(com_aux, "grade", 5)) {
    if (toupper(result[0]) == 'S' || result[0] == '1')
      GRADE = 1;
    else if (toupper(result[0]) == 'N' || result[0] == '0')
      GRADE = 0;
  }

  else if (COMPSTRNI(com_aux, "nivel_cla", 9)) {
    NIVEL_CLASS = atoi(result);
  }

  return 1;
}

/* ------------------------------------------------------------------------- */

int LeConfiguracao(char *nome_arq) {

  FILE *arq_cfg;
  char linha[200], *ch;

  arq_cfg = fopen(nome_arq, "rb");
  if (arq_cfg == NULL) return 0;

  do {
    ch = fgets(linha, 200, arq_cfg);
    if (ch != NULL) if (!InterpretaComando(linha)) return 0;
  } while (ch != NULL);

  fclose(arq_cfg);

  return 1;
}

/* ---------------------------------------------------------------------- */

int IniciaModoGrafico(void) {

  /* Coloca a tela no modo grafico */

  int DriverGrafico, ModoGrafico;
  registerbgidriver(EGAVGA_driver);
  DriverGrafico = DETECT;
  initgraph(&DriverGrafico, &ModoGrafico, "");
  if (graphresult() < 0) {
    printf("\n\nERRO: Nao foi possivel mudar para o modo grafico\n");
    return 0;
  }
  return 1;
}

/* ---------------------------------------------------------------------- */

void ProjetaPonto(double x, double y, double z,
					  double *proj_X, double *proj_Y) {

/* Projeta o ponto (x, y, z) em coordenadas (proj_X, proj_Y) da tela */

  *proj_X = y*cos(TETA) + x*sin(TETA);
  *proj_Y = z*cos(FI) + x*cos(TETA)*sin(FI) - y*sin(FI)*sin(TETA);
}

/* ---------------------------------------------------------------------- */

void DesenhaEixos(int tam, int cor1, int cor2) {

/* Desenha os eixos x, y, z usando tamanho e cores especificados */

  double X0, Y0, X, Y;
  int x_x, x_y, y_x, y_y, z_x, z_y;

  setcolor(cor1);

  ProjetaPonto(0, 0, 0, &X0, &Y0);
  ProjetaPonto(tam, 0, 0, &X, &Y);
  line(X_CENTRO+X0*TAM, Y_CENTRO - Y0*TAM, X_CENTRO + X*TAM, Y_CENTRO - Y*TAM);
  x_x = X_CENTRO + X*TAM; x_y = Y_CENTRO - Y*TAM;

  ProjetaPonto(0, tam, 0, &X, &Y);
  line(X_CENTRO + X0*TAM, Y_CENTRO-Y0*TAM, X_CENTRO + X*TAM, Y_CENTRO - Y*TAM);
  y_x = X_CENTRO + X*TAM; y_y = Y_CENTRO - Y*TAM;

  ProjetaPonto(0, 0, tam, &X, &Y);
  line(X_CENTRO + X0*TAM, Y_CENTRO-Y0*TAM, X_CENTRO + X*TAM, Y_CENTRO - Y*TAM);
  z_x = X_CENTRO + X*TAM; z_y = Y_CENTRO - Y*TAM;

  setcolor(cor2);
  outtextxy(x_x, x_y, "x");
  outtextxy(y_x, y_y, "y");
  outtextxy(z_x, z_y, "z");
}

/* ---------------------------------------------------------------------- */

void DesenhaPonto3D(double X, double Y, double Z, int cor) {

/* Desenha o ponto (X, Y, Z) */

  double proj_X, proj_Y;

  ProjetaPonto(X, Y, Z, &proj_X, &proj_Y);
  putpixel(X_CENTRO + proj_X*TAM, Y_CENTRO - proj_Y*TAM, cor);

}

/* ---------------------------------------------------------------------- */

void MarcaPonto3D(double X, double Y, double Z, int cor) {

/* Desenha o ponto (X, Y, Z) de forma destacada */

  double proj_X, proj_Y;

  ProjetaPonto(X, Y, Z, &proj_X, &proj_Y);
  putpixel(X_CENTRO + proj_X*TAM, Y_CENTRO - proj_Y*TAM, cor);
  putpixel(X_CENTRO + proj_X*TAM + 1, Y_CENTRO - proj_Y*TAM + 1, cor);
  putpixel(X_CENTRO + proj_X*TAM + 1, Y_CENTRO - proj_Y*TAM, cor);
  putpixel(X_CENTRO + proj_X*TAM, Y_CENTRO - proj_Y*TAM + 1, cor);
}

/* ---------------------------------------------------------------------- */

void MarcaPonto3DINI(double X, double Y, double Z, int cor) {

/* Desenha o ponto (X, Y, Z) de forma destacada */

  double proj_X, proj_Y;

  ProjetaPonto(X, Y, Z, &proj_X, &proj_Y);
  putpixel(X_CENTRO + proj_X*TAM - 2, Y_CENTRO - proj_Y*TAM - 2, cor);
  putpixel(X_CENTRO + proj_X*TAM - 2, Y_CENTRO - proj_Y*TAM - 1, cor);
  putpixel(X_CENTRO + proj_X*TAM - 2, Y_CENTRO - proj_Y*TAM, cor);
  putpixel(X_CENTRO + proj_X*TAM - 2, Y_CENTRO - proj_Y*TAM + 1, cor);
  putpixel(X_CENTRO + proj_X*TAM - 2, Y_CENTRO - proj_Y*TAM + 2, cor);

  putpixel(X_CENTRO + proj_X*TAM + 2, Y_CENTRO - proj_Y*TAM - 2, cor);
  putpixel(X_CENTRO + proj_X*TAM + 2, Y_CENTRO - proj_Y*TAM - 1, cor);
  putpixel(X_CENTRO + proj_X*TAM + 2, Y_CENTRO - proj_Y*TAM, cor);
  putpixel(X_CENTRO + proj_X*TAM + 2, Y_CENTRO - proj_Y*TAM + 1, cor);
  putpixel(X_CENTRO + proj_X*TAM + 2, Y_CENTRO - proj_Y*TAM + 2, cor);

  putpixel(X_CENTRO + proj_X*TAM - 2, Y_CENTRO - proj_Y*TAM - 2, cor);
  putpixel(X_CENTRO + proj_X*TAM - 1, Y_CENTRO - proj_Y*TAM - 2, cor);
  putpixel(X_CENTRO + proj_X*TAM, Y_CENTRO - proj_Y*TAM - 2, cor);
  putpixel(X_CENTRO + proj_X*TAM + 1, Y_CENTRO - proj_Y*TAM - 2, cor);
  putpixel(X_CENTRO + proj_X*TAM + 2, Y_CENTRO - proj_Y*TAM - 2, cor);

  putpixel(X_CENTRO + proj_X*TAM - 2, Y_CENTRO - proj_Y*TAM + 2, cor);
  putpixel(X_CENTRO + proj_X*TAM - 1, Y_CENTRO - proj_Y*TAM + 2, cor);
  putpixel(X_CENTRO + proj_X*TAM, Y_CENTRO - proj_Y*TAM + 2, cor);
  putpixel(X_CENTRO + proj_X*TAM + 1, Y_CENTRO - proj_Y*TAM + 2, cor);
  putpixel(X_CENTRO + proj_X*TAM + 2, Y_CENTRO - proj_Y*TAM + 2, cor);
}

/* ---------------------------------------------------------------------- */

void DesenhaSuperficie(double (*f1)(double, double),
	       double (*f2)(double, double), double (*f3)(double, double),
	       double umin, double umax, int nu,
	       double vmin, double vmax, int nv, int cor) {

  double u, v, xp1, yp1, zp1, xp2, yp2, zp2, xp3, yp3, zp3, xp4, yp4, zp4,
	 X, Y, incrU, incrV;
  int xq1, xq2, xq3, xq4, yq1, yq2, yq3, yq4;
  unsigned int padrao = 0x5555u;      /* Padrao das linhas pontilhadas */

  incrU = (umax - umin)/nu;
  incrV = (vmax - vmin)/nv;

  if (LINHA_PONTILHADA) setlinestyle(USERBIT_LINE, padrao, NORM_WIDTH);

  setcolor(cor);

  for (u = umin + incrU; u <= umax + incrU/2; u += incrU)
    for (v = vmin + incrV; v <= vmax + incrV/2; v += incrV) {

      xp1 = f1(u, v);
      yp1 = f2(u, v);
      zp1 = f3(u, v);

      xp2 = f1(u - incrU, v);
      yp2 = f2(u - incrU, v);
      zp2 = f3(u - incrU, v);

      xp3 = f1(u, v - incrV);
      yp3 = f2(u, v - incrV);
      zp3 = f3(u, v - incrV);

      xp4 = f1(u - incrU, v - incrV);
      yp4 = f2(u - incrU, v - incrV);
      zp4 = f3(u - incrU, v - incrV);

      ProjetaPonto(xp1, yp1, zp1, &X, &Y);
      xq1 = X_CENTRO + X*TAM; yq1 = Y_CENTRO - Y*TAM;
      ProjetaPonto(xp2, yp2, zp2, &X, &Y);
      xq2 = X_CENTRO + X*TAM; yq2 = Y_CENTRO - Y*TAM;
      ProjetaPonto(xp3, yp3, zp3, &X, &Y);
      xq3 = X_CENTRO + X*TAM; yq3 = Y_CENTRO - Y*TAM;
      ProjetaPonto(xp4, yp4, zp4, &X, &Y);
      xq4 = X_CENTRO + X*TAM; yq4 = Y_CENTRO - Y*TAM;

      line (xq1, yq1, xq2, yq2);
      line (xq4, yq4, xq2, yq2);
      line (xq3, yq3, xq4, yq4);
      line (xq3, yq3, xq1, yq1);
    }

  if (LINHA_PONTILHADA) setlinestyle(SOLID_LINE, 0xffffu, NORM_WIDTH);

}

/* ---------------------------------------------------------------------- */

void MarcaPontoDominio(double u, double v, int a, int b, int c, int d,
		       int cor, int cor_eixos, double x1, double x2,
		       double y1, double y2, char *mens) {

/* Marca o ponto (u, v) do dominio da parametrizacao de uma superficie.
   E' usado um retangulo definido pelos vertices (a, b) e (c, d).   */

  int i, j, k, A, B, ex, ey;
  double maxx, maxy;
  static int a2 = 0, b2 = 0, c2 = 0, d2 = 0;
  static int vez = 1;

  int opcao = 1;
  /* Se opcao for um valor maior do que 1, entao os dominios sao subdivi-
   didos em "opcao" partes iguais. */

  int desenhar_pontos = DESENHAR_PONTOS_DOM;
  /*  Os pontos so' sao marcados no dominio se "desenhar_pontos" for
      diferente de 0 */

  if (GRADE) for (k = 1; k <= NIVEL_CLASS; k++) opcao *= 2;

  if (a != a2 || b != b2 || c != c2 || d != d2) {
    a2 = a, b2 = b, c2 = c, d2 = d;
    maxy = d - b, maxx = c - a;
    ex = (maxy*y2)/(y2 - y1);
    ey = (maxx*x1)/(x1 - x2);
    setcolor(cor_eixos);
    line(a, b + ex, a + maxx, b + ex);
    line(a + ey, b, a + ey, b + maxy);
    rectangle(a, b, c, d);
    if (opcao >= 2) {
      for (j = 1; j <= opcao - 1; j++) {
	line(a + j*(c - a)/opcao, b, a + j*(c - a)/opcao, d);
	line(a, b + j*(d - b)/opcao, c, b + j*(d - b)/opcao);
      }
    }

    if (vez <= 2) {
      i = 0;
      while (mens[i] != '\0') {
	if (mens[i] == '_') mens[i] = ' ';
	if (mens[i] <= 13) { mens[i] = '\0'; break; }
	i++;
      }
      vez++;
      setcolor(cor);
      outtextxy(a, b - 10, mens);
    }
  }

  if (desenhar_pontos) {
    A = a + (u - x1)/(x2 - x1)*maxx;
    B = b + maxy*(y2 - v)/(y2 - y1);
    if (a <= A && A <= c && b <= B && B <= d) putpixel(A, B, cor);
  }
}

/* ---------------------------------------------------------------------- */

void ReajustaRegiaoDominio(int *a, int *b, int *c, int *d,
		       int acrescimo_vertical, int acrescimo_horizontal) {

/* Verifica e reajusta cantos superior esquerdo e inferior direito de
   determinada regiao do dominio. */

  int maxX, maxY;

  maxX = getmaxx(), maxY = getmaxy();

  if (*d + acrescimo_vertical > maxY) {
    *b -= *d + acrescimo_vertical - maxY;
    *d -= *d + acrescimo_vertical - maxY;
  }

  if (*c + acrescimo_horizontal > maxX) {
    *a -= *c + acrescimo_horizontal - maxX;
    *c -= *c + acrescimo_horizontal - maxX;
  }
}

/* ----------------------------------------------------------------------- */

int ConstruirGrafico(void) {

  int larg = 10, alt = 35;

  IniciaModoGrafico();
  setbkcolor(COR_FUNDO);
  ReajustaRegiaoDominio(&a_domF, &b_domF, &c_domF, &d_domF, alt, larg);
  ReajustaRegiaoDominio(&a_domG, &b_domG, &c_domG, &d_domG, alt, larg);
  cleardevice();
  if (DES_EIXOS) DesenhaEixos(TAM_EIXOS, COR_EIXOS, COR_EIXOS);
  DesenhaSuperficie(f1, f2, f3, Ret1.xmin, Ret1.xmax, nuF,
				  Ret1.ymin, Ret1.ymax, nvF, COR_GRAF1);
  DesenhaSuperficie(g1, g2, g3, Ret2.xmin, Ret2.xmax, nuG,
				  Ret2.ymin, Ret2.ymax, nvG, COR_GRAF2);
   return 1;
}

/* ------------------------------------------------------------------------- */

int TestaPonto(double p1, double p2, double p3, double u1, double v1,
						       double u2, double v2) {

  double erro = 0.1;

  return (fabs(p1 - f1(u1, v1)) < erro && fabs(p1 - g1(u2, v2)) < erro &&
	  fabs(p2 - f2(u1, v1)) < erro && fabs(p2 - g2(u2, v2)) < erro &&
	  fabs(p3 - f3(u1, v1)) < erro && fabs(p3 - g3(u2, v2)) < erro);
}

/* ------------------------------------------------------------------------- */

void NomeArquivoCfg(char *nome_basico, char *extensao, char *nome_arq) {

  int tam, barra, ponto;

  barra = PosUlt('\\', nome_basico);
  tam = strlen(nome_basico);
  Substr(nome_basico, barra + 1, tam);
  ponto = Pos('.', nome_basico);
  Substr(nome_basico, 0, ponto - 1);
  if (strlen(extensao) > 0)
    sprintf(nome_arq, "%s.%s", nome_basico, extensao);
  else
    strcpy(nome_arq, nome_basico);
}

/* ------------------------------------------------------------------------- */

#ifdef PONTOS3DV

void Pontos3DV(char *nome_origem, char *nome_destino, unsigned quant) {

/* Gera arquivo no formato .3DV. Para ser utilizado com o programa
   3DV.EXE que pode copiado de ftp.simtel.net/pub/simtelnet/msdos/graph/ */

  double u, v, incru_f, incrv_f, incru_g, incrv_g;
  unsigned i, j;
  float x, y, z, p0u, p0v, q0u, q0v;
  char linha[200], *ch;
  FILE *origem, *destino;

  origem = fopen(nome_origem, "rb");
  if (origem == NULL) return;
  ch = fgets(linha, 200, origem);
  if (ch != NULL) {
    if (!COMPSTRNI(linha, "(ponto inter", 12)) {
      fclose(origem);
      origem = fopen(nome_origem, "rb");
    }
  }
  destino = fopen(nome_destino, "wb");
  if (destino == NULL) return;

  incru_f = (Ret1.xmax - Ret1.xmin)/nuF;
  incrv_f = (Ret1.ymax - Ret1.ymin)/nvF;
  incru_g = (Ret2.xmax - Ret2.xmin)/nuG;
  incrv_g = (Ret2.ymax - Ret2.ymin)/nvG;

  fprintf(destino, "%u\n", quant + (nuF+1)*(nvF+1) + (nuG+1)*(nvG+1));
  for (v = Ret1.ymin; v < Ret1.ymax + incrv_f/2; v += incrv_f)
    for (u = Ret1.xmin; u < Ret1.xmax + incru_f/2; u+= incru_f)
      fprintf(destino, "%6.3f %6.3f %6.3f\n", f1(u, v), f2(u, v), f3(u, v));
  for (v = Ret2.ymin; v < Ret2.ymax + incrv_g/2; v += incrv_g)
    for (u = Ret2.xmin; u < Ret2.xmax + incru_g/2; u+= incru_g)
      fprintf(destino, "%6.3f %6.3f %6.3f\n", g1(u, v), g2(u, v), g3(u, v));

  do {
    ch = fgets(linha, 200, origem);
    if (ch == NULL) break;
    sscanf(linha, "(%f %f %f) (%f %f) (%f %f)", &x, &y, &z,&p0u,&p0v,&q0u,&q0v);
    if (!TestaPonto(x, y, z, p0u, p0v, q0u, q0v)) continue;
    fprintf(destino, "%6.3f %6.3f %6.3f\n", x, y, z);
  } while (ch != NULL);

  fprintf(destino, "%u\n", 2*(nuF+1)*(nvF+1) + 2*(nuG+1)*(nvG+1) + 2*quant);

  for (i = 1; i <= (nuF + 1)*(nvF + 1); i++)
    if (i % (nuF + 1) == 1)
      fprintf(destino, "%u %u\n", i, 0);
    else
      fprintf(destino, "%u %u\n", i, COR_GRAF1);
  for (i = 1; i <= nuF + 1; i++)
    for (j = 0; j <= nvF; j++)
      if (j == 0)
	fprintf(destino, "%u %u\n", i + j*(1 + nuF), 0);
      else
	fprintf(destino, "%u %u\n", i + j*(1 + nuF), COR_GRAF1);

  for (i = 1 + (nuG + 1)*(nvG + 1); i <= 2*(nuG + 1)*(nvG + 1); i++)
    if (i % (nuG + 1) == 1)
      fprintf(destino, "%u %u\n", i, 0);
    else
      fprintf(destino, "%u %u\n", i, COR_GRAF2);
  for (i = 1 + (nuG+1)*(nvG+1); i <= nuG + 1 + (nuG+1)*(nvG+1); i++)
    for (j = 0; j <= nvG; j++)
      if (j == 0)
	fprintf(destino, "%u %u\n", i + j*(1 + nuG), 0);
      else
	fprintf(destino, "%u %u\n", i + j*(1 + nuG), COR_GRAF2);

  for (i = 1 + (nuF+1)*(nvF+1) + (nuG+1)*(nvG+1);
       i <=    (nuF+1)*(nvF+1) + (nuG+1)*(nvG+1) + quant; i++) {
    fprintf(destino, "%u %u\n", i, 0);
    fprintf(destino, "%u %u\n", i, COR_INTER);
  }

  for (i = 1 + (nuF+1)*(nvF+1) + (nuG+1)*(nvG+1);
       i <=    (nuF+1)*(nvF+1) + (nuG+1)*(nvG+1) + quant; i++) {
    fprintf(destino, "%u %u\n", i, 0);
    fprintf(destino, "%u %u\n", i, COR_INTER);
  }

  fclose(origem);
  fclose(destino);
}

#endif

/* ------------------------------------------------------------------------- */

unsigned int pt3D[21] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
int pX, pY;

void RestauraXPontos3D(void) {

  setviewport(0, 0, getmaxx(), getmaxy(), 0);

  putpixel(pX, pY, pt3D[0]);
  putpixel(pX + 1, pY + 1, pt3D[1]);
  putpixel(pX + 1, pY - 1, pt3D[2]);
  putpixel(pX - 1, pY + 1, pt3D[3]);
  putpixel(pX - 1, pY - 1, pt3D[4]);
  putpixel(pX + 2, pY + 2, pt3D[5]);
  putpixel(pX + 2, pY - 2, pt3D[6]);
  putpixel(pX - 2, pY + 2, pt3D[7]);
  putpixel(pX - 2, pY - 2, pt3D[8]);
  putpixel(pX + 3, pY - 1, pt3D[9]);
  putpixel(pX + 3, pY, pt3D[10]);
  putpixel(pX + 3, pY + 1, pt3D[11]);
  putpixel(pX - 3, pY - 1, pt3D[12]);
  putpixel(pX - 3, pY, pt3D[13]);
  putpixel(pX - 3, pY + 1, pt3D[14]);
  putpixel(pX - 1, pY - 3, pt3D[15]);
  putpixel(pX, pY - 3, pt3D[16]);
  putpixel(pX + 1, pY - 3, pt3D[17]);
  putpixel(pX - 1, pY + 3, pt3D[18]);
  putpixel(pX, pY + 3, pt3D[19]);
  putpixel(pX + 1, pY + 3, pt3D[20]);
}

/* ---------------------------------------------------------------------- */

void ConverteCoordenadas(double *u, double *v, int A, int B, int a, int b,
	 int c, int d, double xmin, double xmax, double ymin, double ymax) {

/* Converte as coordenadas (A, B) da tela no retangulo (a, c) - (b, d)
   em  coordenadas  cartesianas  (*u, *v)  com  relacao  ao  retangulo
   (xmin, ymin) - (xmax, ymax) */

  double maxx, maxy;

  maxy = d - b, maxx = c - a;
  *u = xmin + (A - a)*(xmax - xmin)/maxx;
  *v = ymax - (B - b)*(ymax - ymin)/maxy;
}

/* ---------------------------------------------------------------------- */

void MarcaPonto3Dx2(double X, double Y, double Z, int cor) {

/* Desenha o ponto (X, Y, Z) no formato de um "x" */

  double p1, p2;

  setviewport(0, 0, getmaxx(), getmaxy(), 0);

  ProjetaPonto(X, Y, Z, &p1, &p2);
  pX = X_CENTRO + p1*TAM, pY = Y_CENTRO - p2*TAM;

  pt3D[0] = getpixel(pX, pY);
  pt3D[1] = getpixel(pX + 1, pY + 1);
  pt3D[2] = getpixel(pX + 1, pY - 1);
  pt3D[3] = getpixel(pX - 1, pY + 1);
  pt3D[4] = getpixel(pX - 1, pY - 1);
  pt3D[5] = getpixel(pX + 2, pY + 2);
  pt3D[6] = getpixel(pX + 2, pY - 2);
  pt3D[7] = getpixel(pX - 2, pY + 2);
  pt3D[8] = getpixel(pX - 2, pY - 2);
  pt3D[9] = getpixel(pX + 3, pY - 1);
  pt3D[10] = getpixel(pX + 3, pY);
  pt3D[11] = getpixel(pX + 3, pY + 1);
  pt3D[12] = getpixel(pX - 3, pY - 1);
  pt3D[13] = getpixel(pX - 3, pY);
  pt3D[14] = getpixel(pX - 3, pY + 1);
  pt3D[15] = getpixel(pX - 1, pY - 3);
  pt3D[16] = getpixel(pX, pY - 3);
  pt3D[17] = getpixel(pX + 1, pY - 3);
  pt3D[18] = getpixel(pX - 1, pY + 3);
  pt3D[19] = getpixel(pX, pY + 3);
  pt3D[20] = getpixel(pX + 1, pY + 3);

  putpixel(pX, pY, cor);
  putpixel(pX + 1, pY + 1, cor);
  putpixel(pX + 1, pY - 1, cor);
  putpixel(pX - 1, pY + 1, cor);
  putpixel(pX - 1, pY - 1, cor);
  putpixel(pX + 2, pY + 2, cor);
  putpixel(pX + 2, pY - 2, cor);
  putpixel(pX - 2, pY + 2, cor);
  putpixel(pX - 2, pY - 2, cor);
  putpixel(pX + 3, pY - 1, cor);
  putpixel(pX + 3, pY, cor);
  putpixel(pX + 3, pY + 1, cor);
  putpixel(pX - 3, pY - 1, cor);
  putpixel(pX - 3, pY, cor);
  putpixel(pX - 3, pY + 1, cor);
  putpixel(pX - 1, pY - 3, cor);
  putpixel(pX, pY - 3, cor);
  putpixel(pX + 1, pY - 3, cor);
  putpixel(pX - 1, pY + 3, cor);
  putpixel(pX, pY + 3, cor);
  putpixel(pX + 1, pY + 3, cor);
}

/* ---------------------------------------------------------------------- */

void Limpa(int a, int b, int c, int d) {

  EscondeIndicadorDoMouse();
  setviewport(a, b, c, d, 0);
  clearviewport();
  MostraIndicadorDoMouse();
}

/* ----------------------------------------------------------------------- */

void VerificaMouse(void) {

  int reajustar = 1, xmouse, ymouse;
  char mouse_mens1[100], mouse_mens2[100];
  double mouse_u, mouse_v, mouse_u_anterior, mouse_v_anterior;
  int ajustarpt3D = 0, larg = 10, alt = 35;

  AjustaLimitesVerticais(0, getmaxy());
  AjustaLimitesHorizontais(0, getmaxx());
  MostraIndicadorDoMouse();
  mouse_u_anterior = mouse_v_anterior = INF;
  do {

    /* Indicador do mouse no dominio de F */
    if (VerificaPosIndicadorDoMouse(a_domF, b_domF, c_domF, d_domF)) {
      reajustar = 1;
      ObtemPosicaoDoIndicadorDoMouse(&xmouse, &ymouse);
      ConverteCoordenadas(&mouse_u, &mouse_v, xmouse, ymouse, a_domF, b_domF,
	c_domF, d_domF, Ret1.xmin, Ret1.xmax, Ret1.ymin, Ret1.ymax);
      sprintf(mouse_mens1, "F(%4.4f, %4.4f) =", mouse_u, mouse_v);
      sprintf(mouse_mens2, "(%3.3f %3.3f %3.3f)", f1(mouse_u, mouse_v),
			      f2(mouse_u, mouse_v), f3(mouse_u, mouse_v));
      mouse_mens1[20] = mouse_mens2[20] = '\0';
      if (mouse_u != mouse_u_anterior || mouse_v != mouse_v_anterior) {
	if (ajustarpt3D) {
	  ajustarpt3D = 0;
	  RestauraXPontos3D();
	}
	AjustaFormaDoIndicadorGrafico(X_CROSS, Y_CROSS, (long) Cross);
	setcolor(cor_pontos_domF);
	Limpa(a_domG, d_domG + 10, c_domG + larg, d_domG + alt);
	Limpa(a_domF, d_domF + 10, c_domF + larg, d_domF + alt);
	outtextxy(0, 0, mouse_mens1);
	outtextxy(0, 15, mouse_mens2);
	mouse_u_anterior = mouse_u, mouse_v_anterior = mouse_v;
      }
      if (BotaoPressionado(&xmouse, &ymouse)) {
	ConverteCoordenadas(&mouse_u, &mouse_v, xmouse, ymouse,a_domF,b_domF,
	  c_domF, d_domF, Ret1.xmin, Ret1.xmax, Ret1.ymin, Ret1.ymax);
	MarcaPonto3Dx2(f1(mouse_u, mouse_v), f2(mouse_u, mouse_v),
	  f3(mouse_u, mouse_v), corX3D);
	delay(500);
	ajustarpt3D = 1;
      }

    /* Indicador do mouse no dominio de G */
    } else if (VerificaPosIndicadorDoMouse(a_domG, b_domG, c_domG, d_domG)) {
      reajustar = 1;
      ObtemPosicaoDoIndicadorDoMouse(&xmouse, &ymouse);
      ConverteCoordenadas(&mouse_u, &mouse_v, xmouse, ymouse, a_domG, b_domG,
	  c_domG, d_domG, Ret2.xmin, Ret2.xmax, Ret2.ymin, Ret2.ymax);
      sprintf(mouse_mens1, "G(%4.4f, %4.4f) =", mouse_u, mouse_v);
      sprintf(mouse_mens2, "(%3.3f %3.3f %3.3f)", g1(mouse_u, mouse_v),
			      g2(mouse_u, mouse_v), g3(mouse_u, mouse_v));
      if (mouse_u != mouse_u_anterior || mouse_v != mouse_v_anterior) {
	if (ajustarpt3D) {
	  ajustarpt3D = 0;
	  RestauraXPontos3D();
	}
	AjustaFormaDoIndicadorGrafico(X_CROSS, Y_CROSS, (long) Cross);
	setcolor(cor_pontos_domG);
	Limpa(a_domF, d_domF + 10, c_domF + larg, d_domF + alt);
	Limpa(a_domG, d_domG + 10, c_domG + larg, d_domG + alt);
	mouse_mens1[20] = mouse_mens2[20] = '\0';
	outtextxy(0, 0, mouse_mens1);
	outtextxy(0, 15, mouse_mens2);
	mouse_u_anterior = mouse_u, mouse_v_anterior = mouse_v;
      }
      if (BotaoPressionado(&xmouse, &ymouse)) {
	ConverteCoordenadas(&mouse_u, &mouse_v, xmouse,ymouse,a_domG,b_domG,
		  c_domG, d_domG, Ret2.xmin, Ret2.xmax, Ret2.ymin, Ret2.ymax);
	MarcaPonto3Dx2(g1(mouse_u, mouse_v), g2(mouse_u, mouse_v),
					    g3(mouse_u, mouse_v), corX3D);
	delay(500);
	ajustarpt3D = 1;
      }

    /* Indicador do mouse fora dos dominios de F e de G */
    } else {
      if (reajustar) {
	reajustar = 0;
	Limpa(a_domF, d_domF + 10, c_domF + larg, d_domF + alt);
	Limpa(a_domG, d_domG + 10, c_domG + larg, d_domG + alt);
	AjustaFormaDoIndicadorGrafico(X_ARROW, Y_ARROW, (long) Arrow);
	if (ajustarpt3D) {
	  ajustarpt3D = 0;
	  RestauraXPontos3D();
	}
      }
    }
  } while (!kbhit());
}

/* ---------------------------------------------------------------------- */

retangulo SelecionaRetangulo(int n, retangulo X) {

/*  Seleciona um subretangulo 1, 2, 3 ou 4 do retangulo X.

	       X.ymax -- +-----+-----+
			 |  1  |  2  |
			 +-----+-----+
			 |  3  |  4  |
	       X.ymin -- +-----+-----+
			 |           |
		      X.xmin      X.xmax
*/

  retangulo R;

  if (n == 1) { R.xmin = X.xmin, R.xmax = (X.xmin + X.xmax)/2,
		R.ymin = (X.ymin + X.ymax)/2, R.ymax = X.ymax; }

  else if (n == 2) { R.xmin = (X.xmin + X.xmax)/2, R.xmax = X.xmax,
		R.ymin = (X.ymin + X.ymax)/2, R.ymax = X.ymax; }

  else if (n == 3) { R.xmin = X.xmin, R.xmax = (X.xmin + X.xmax)/2,
		R.ymin = X.ymin, R.ymax = (X.ymin + X.ymax)/2; }

  else { R.xmin = (X.xmin + X.xmax)/2, R.xmax = X.xmax,
		R.ymin = X.ymin, R.ymax = (X.ymin + X.ymax)/2; }

  return R;
}

/* ---------------------------------------------------------------------- */

void PontoEmRetangulo(char *r, retangulo R, double *x, double *y) {

/* Determina que ponto do dominio esta' associado `a representacao r */

  int i = 0;

  while (r[i]) {
    if (r[i] == '1') R = SelecionaRetangulo(1, R);
    else if (r[i] == '2') R = SelecionaRetangulo(2, R);
    else if (r[i] == '3') R = SelecionaRetangulo(3, R);
    else R = SelecionaRetangulo(4, R);
    i++;
  }
  *x = (R.xmin + R.xmax)/2, *y = (R.ymin + R.ymax)/2;
}

/* ---------------------------------------------------------------------- */

void MarcaPontosSubdivisao (char *Nome_Arq) {

  ponto_dominio p0, q0;
  char *ch, linha[100], linha1[50], linha2[50];
  FILE *arq;
  float dist;

  if ((arq = fopen(Nome_Arq, "rt")) == NULL) return;

  do {
    ch = fgets(linha, 100, arq);
    if (ch != NULL) {
      if (linha[0] == '1' || linha[0] == '2' ||
	  linha[0] == '3' || linha[0] == '4')
	sscanf(linha, "%s %s [%f]", linha1, linha2, &dist);
      PontoEmRetangulo(linha1, Ret1, &p0.u, &p0.v);
      PontoEmRetangulo(linha2, Ret2, &q0.u, &q0.v);
      MarcaXDominio(p0.u, p0.v, a_domF, b_domF, c_domF, d_domF,
	     X_COR_DOMINIO, Ret1.xmin, Ret1.xmax, Ret1.ymin, Ret1.ymax);
      MarcaXDominio(q0.u, q0.v, a_domG, b_domG, c_domG, d_domG,
	     X_COR_DOMINIO, Ret2.xmin, Ret2.xmax, Ret2.ymin, Ret2.ymax);
    }
  } while (ch != NULL);

  fclose(arq);

  if (!DOMINIO2) return;

  if ((arq = fopen(DIV_CLASS2, "rt")) == NULL) return;

  do {
    ch = fgets(linha, 100, arq);
    if (ch != NULL) {
      if (linha[0] == '1' || linha[0] == '2' ||
	  linha[0] == '3' || linha[0] == '4')
	sscanf(linha, "%s %s [%f]", linha1, linha2, &dist);
      PontoEmRetangulo(linha1, Ret1, &p0.u, &p0.v);
      PontoEmRetangulo(linha2, Ret2, &q0.u, &q0.v);
      MarcaXDominio(p0.u, p0.v, a_domF, b_domF, c_domF, d_domF,
	     X_COR_DOMINIO, Ret1.xmin, Ret1.xmax, Ret1.ymin, Ret1.ymax);
      MarcaXDominio(q0.u, q0.v, a_domG, b_domG, c_domG, d_domG,
	     X_COR_DOMINIO, Ret2.xmin, Ret2.xmax, Ret2.ymin, Ret2.ymax);
    }
  } while (ch != NULL);

  fclose(arq);
}

/* ----------------------------------------------------------------------- */

void main(int argc, char *argv[]) {

  FILE *arq;
  char arq_3DV[100], nome_arq[100], linha[200], *ch, nome_prog[100];
  float x, y, z, p0u, p0v, q0u, q0v;
  unsigned mouse, quant_pontos_inters = 0;

  #include "ajustes.c"

  if (argc > 1) {
    strcpy(nome_arq, argv[1]);
  } else {
    NomeArquivoCfg(argv[0], "", nome_prog);
    printf("\n*** Constroi graficos usando o arquivo de dados padrao ***\n");
    printf("\nForma de usar: %s arq_origem\n", nome_prog);
    printf("\nExemplo: %s dados.txt\n", nome_prog);
    return;
  }

  arq = fopen(nome_arq, "rb");
  if (arq == NULL) return;
  NomeArquivoCfg(argv[0], "cfg", ARQ_CONFIGURACAO);
  LeConfiguracao(ARQ_CONFIGURACAO);
  if (!ConstruirGrafico()) return;

  if (X_PONTOS_SUBDIVISAO)
    MarcaPontosSubdivisao(DIV_NOME_ARQ /*DIV_CLASS1*/);

  ch = fgets(linha, 200, arq);
  if (ch != NULL) {
    if (!COMPSTRNI(linha, "(ponto inter", 12)) {
      fclose(arq);
      arq = fopen(nome_arq, "rb");
    }
  }

  do {
    ch = fgets(linha, 200, arq);
    if (ch == NULL) break;

    sscanf(linha, "(%f %f %f) (%f %f) (%f %f)", &x,&y,&z,&p0u,&p0v,&q0u,&q0v);

    if (!TestaPonto(x, y, z, p0u, p0v, q0u, q0v)) continue;

    quant_pontos_inters++;

    if (DEMORA) delay(DEMORA);

    if (GRAF_X)
      MarcaPonto3D(f1(p0u, p0v), f2(p0u, p0v), f3(p0u, p0v), COR_INTER);
    else
      DesenhaPonto3D(f1(p0u, p0v), f2(p0u, p0v), f3(p0u, p0v), COR_INTER);

    MarcaPontoDominio(p0u, p0v, a_domF, b_domF, c_domF, d_domF,
		     cor_pontos_domF, cor_molduraF,
		     Ret1.xmin, Ret1.xmax, Ret1.ymin, Ret1.ymax, mens_Dom_F);
    MarcaPontoDominio(q0u, q0v, a_domG, b_domG, c_domG, d_domG,
		     cor_pontos_domG, cor_molduraG,
		     Ret2.xmin, Ret2.xmax, Ret2.ymin, Ret2.ymax, mens_Dom_G);

   if (INICIAL) {
     if (ContaStr(linha, "INICIO(1)")) {
      MarcaPontoINI(p0u, p0v, a_domF, b_domF, c_domF, d_domF,
	     cor_pontos_domF, Ret1.xmin, Ret1.xmax, Ret1.ymin, Ret1.ymax, 1);
      MarcaPontoINI(q0u, q0v, a_domG, b_domG, c_domG, d_domG,
	     cor_pontos_domG, Ret2.xmin, Ret2.xmax, Ret2.ymin, Ret2.ymax, 1);
      MarcaPonto3DINI(f1(p0u, p0v), f2(p0u, p0v), f3(p0u, p0v), COR_INTER);
     } else if (ContaStr(linha, "FIM(1)") || ContaStr(linha, "FIM(3)")) {
      MarcaPontoINI(p0u, p0v, a_domF, b_domF, c_domF, d_domF,
	     cor_pontos_domF, Ret1.xmin, Ret1.xmax, Ret1.ymin, Ret1.ymax, 0);
      MarcaPontoINI(q0u, q0v, a_domG, b_domG, c_domG, d_domG,
	     cor_pontos_domG, Ret2.xmin, Ret2.xmax, Ret2.ymin, Ret2.ymax, 0);
     }
   }

  } while (ch != NULL);
  fclose(arq);

  NomeArquivoCfg(argv[0], "3DV", arq_3DV);
  #ifdef PONTOS3DV
  Pontos3DV(nome_arq, arq_3DV, quant_pontos_inters);
  #endif

  if (USAR_MOUSE) mouse = HaSuporteAoMouse(); else mouse = 0;
  if (mouse) VerificaMouse(); else getch();
  closegraph();
}

/* ------------------------------------------------------------------------- */

/*** FIM DE GDADOS.C ***/
